'  ------------------------------------------------------------------------------------
'  irr::core::array<vector3df> wrappers
'  NOTES:
'  - for regular data types use Var IrrCore_() to get the actual value
'  - did not implement:
	'Function IrrCore_Array_vector3df_linear_reverse_search:Int(parray_vector3df_arr:Int,find:Int)
	'Function IrrCore_Array_vector3df_linear_search:Int(parray_vector3df_arr:Int,find:Int)
	'Function IrrCore_Array_vector3df_binary_search:Int(parray_vector3df_arr:Int,find:Int)
	'Function IrrCore_Array_vector3df_binary_searchWithBounds:Int(parray_vector3df_arr:Int,find:Int,nLeft:Int,nRight:Int)
	'Function IrrCore_Array_vector3df_sort(parray_vector3df_arr:Int)
	'Function IrrCore_Array_vector3df_const_pointer:Int(parray_vector3df_arr:Int)
	'Function IrrCore_Array_vector3df_pointer:Int(parray_vector3df_arr:Int)
	'Function IrrCore_Array_vector3df_set_pointer(parray_vector3df_arr:Int,newPointer:Int,size:Int)
'  ------------------------------------------------------------------------------------

Public

Type Array_vector3df Extends IrrBase Final

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createWithSize:Array_vector3df(start_count:Int)
		Return createFromHandle(IrrCore_Array_vector3df_newWithSize(start_count))
	EndFunction
	
	Function createFromOther:Array_vector3df(other:Array_vector3df)
		Return createFromHandle(IrrCore_Array_vector3df_newFromOther(other.handle))
	EndFunction

	Function create:Array_vector3df()
		Return createFromHandle(IrrCore_Array_vector3df_new())
	EndFunction
	
	Function createFromHandle:Array_vector3df(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:Array_vector3df=New Array_vector3df
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Array_vector3df_del(handle)
	EndMethod	

	'--------------------------------------------
	' the rest
	'--------------------------------------------
	
	Method allocated_size:Int()
		Return IrrCore_Array_vector3df_allocated_size(handle)
	EndMethod

	Method clear()
		IrrCore_Array_vector3df_clear(handle)
	EndMethod

	Method empty:Int()
		Return IrrCore_Array_vector3df_empty(handle)
	EndMethod
	
	Method eraseWithCount(idx:Int,count:Int)
		IrrCore_Array_vector3df_eraseWithCount(handle,idx,count)
	EndMethod
	
	Method erase(idx:Int)
		IrrCore_Array_vector3df_erase(handle,idx)
	EndMethod

	Method reallocate(new_size:Int)
		IrrCore_Array_vector3df_reallocate(handle,new_size)
	EndMethod
	
	Method set_free_when_destroyed(bNewVal:Int)
		IrrCore_Array_vector3df_set_free_when_destroyed(handle,bNewVal)
	EndMethod

	Method set_sorted(bVal:Int)
		IrrCore_Array_vector3df_set_sorted(handle,bVal)
	EndMethod
	
	Method set_used(used:Int)
		IrrCore_Array_vector3df_set_used(handle,used)
	EndMethod
	
	Method size:Int()
		Return IrrCore_Array_vector3df_size(handle)
	EndMethod

	Method getLast:Vector3df()
		'  do Not Delete this pointer
		Return Vector3df.createFromHandle(IrrCore_Array_vector3df_getLast(handle),False)
	EndMethod

	Method elementAt:Vector3df(idx:Int)
		'  do Not Delete this pointer
		Return Vector3df.createFromHandle(IrrCore_Array_vector3df_elementAt(handle,idx),False)
	EndMethod
	
	Method insert(element:Vector3df,idx:Int=0)
		IrrCore_Array_vector3df_insert(handle,element.handle,idx)
	EndMethod

	Method Eq(other:Array_vector3df)
		IrrCore_Array_vector3df_Eq(handle,other.handle)
	EndMethod

	Method push_back(element:Vector3df)
		IrrCore_Array_vector3df_push_back(handle,element.handle)
	EndMethod
	
	Method push_front(element:Vector3df)
		IrrCore_Array_vector3df_push_front(handle,element.handle)
	EndMethod
		
EndType



