' ------------------------------------------------------------------------------------
' irr::core::rect<s32> wrappers (done)
' ------------------------------------------------------------------------------------

Public

Type Recti Extends IrrBase Final

	Method PlusEq:Recti(other:Recti)
		IrrCore_Recti_PlusEq(handle,other.handle)
		Return Self
	EndMethod

	Method Plus:Recti(other:Recti)
		Return createFromHandle(IrrCore_Recti_Plus(handle,other.handle),True)
	EndMethod

	Method MinusEq:Recti(other:Recti)
		IrrCore_Recti_MinusEq(handle,other.handle)
		Return Self
	EndMethod
	
	Method Minus:Recti(other:Recti)
		Return createFromHandle(IrrCore_Recti_Minus(handle,other.handle),True)
	EndMethod
	
	Method EqEq:Int(other:Recti)
		Return IrrCore_Recti_EqEq(handle,other.handle)
	EndMethod
	Method NotEq:Int(other:Recti)
		Return IrrCore_Recti_NotEq(handle,other.handle)
	EndMethod

	Method isPointInside:Int(pPos:Position2di)
		Return IrrCore_Recti_isPointInside(handle,pPos.handle)
	EndMethod
	Method isRectCollided:Int(other:Recti)
		Return IrrCore_Recti_isRectCollided(handle,other.handle)
	EndMethod
	Method clipAgainst(other:Recti)
		IrrCore_Recti_clipAgainst(handle,other.handle) 
	EndMethod
	Method getWidth:Int()
		Return IrrCore_Recti_getWidth(handle)
	EndMethod
	Method getHeight:Int()
		Return IrrCore_Recti_getHeight(handle)
	EndMethod
	Method repair()
		IrrCore_Recti_repair(handle) 
	EndMethod
	Method isValid:Int()
		Return IrrCore_Recti_isValid(handle)
	EndMethod
	Method getCenter:Position2di()
		Return Position2di.createFromHandle(IrrCore_Recti_getCenter(handle))
	EndMethod
	Method getUpperLeftCorner:Position2di()
		' dont delete
		Return Position2di.createFromHandle(IrrCore_Recti_getUpperLeftCorner(handle),False)
	EndMethod
	Method getLowerRightCorner:Position2di()
		' dont delete
		Return Position2di.createFromHandle(IrrCore_Recti_getLowerRightCorner(handle),False)
	EndMethod
	Method getSize:Dimension2di()
		Return Dimension2di.createFromHandle(IrrCore_Recti_getSize(handle))
	EndMethod
	Method addInternalPointFromPos(pos:Position2di)
		IrrCore_Recti_addInternalPointFromPos(handle,pos.handle)
	EndMethod	
	Method addInternalPoint(x:Int,y:Int)
		IrrCore_Recti_addInternalPoint(handle,x,y)
	EndMethod

	Method getArea:Int()
		Return IrrCore_Recti_getArea(handle)
	EndMethod
	
	Method constrainTo:Int(other:Recti)
		Return IrrCore_Recti_constrainTo(handle,other.handle)
	EndMethod
	
	Method Less:Int(other:Recti)
		Return IrrCore_Recti_Less(handle,other.handle)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Recti()
		Return createFromHandle(IrrCore_Recti_new())
	EndFunction

	Function createFromVals:Recti(x1:Int=0,y1:Int=0,x2:Int=0,y2:Int=0)
		Return createFromHandle(IrrCore_Recti_newFromVals(x1,y1,x2,y2))
	EndFunction

	Function createFromPos:Recti(pUpperLeft:Position2di,pLowerRight:Position2di)
		Return createFromHandle(IrrCore_Recti_newFromPos(pUpperLeft.handle,pLowerRight.handle))
	EndFunction

	Function createFromPosSize:Recti(pPos:Position2di,pSize:Dimension2di)
		Return createFromHandle(IrrCore_Recti_newFromPosSize(pPos.handle,pSize.handle))
	EndFunction

	Function createFromRect:Recti(pRect:Recti)
		Return createFromHandle(IrrCore_Recti_newFromRect(pRect.handle))
	EndFunction
	
	Function createFromHandle:Recti(pRect:Int,bMustDel:Int=True)
		If Not pRect Then Return Null
		Local oRetVal:Recti=New Recti
		oRetVal.attach(pRect,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Recti_del(handle)
	EndMethod	
EndType
