' ------------------------------------------------------------------------------------
'  irr::gui::ICursorControl wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------

Public

Type ICursorControl Extends IReferenceCounted Final

	Function createFromHandle:ICursorControl(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:ICursorControl=New ICursorControl
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getPosition:Position2di()
		Return Position2di.createFromHandle(IrrGUI_ICursorControl_getPosition(handle), False)
	EndMethod
	
	Method getRelativePosition:Position2df()
		Return Position2df.createFromHandle(IrrGUI_ICursorControl_getRelativePosition(handle))
	EndMethod
	
	Method isVisible:Int() 
		Return IrrGUI_ICursorControl_isVisible(handle)
	EndMethod
	
	Method setVisible(bVisible:Int)
		IrrGUI_ICursorControl_setVisible(handle,bVisible)
	EndMethod
	
	Method setPositionInt(x:Int,y:Int)
		IrrGUI_ICursorControl_setPositionInt(handle,x,y)
	EndMethod
	
	Method setPositionIntFromPos(pos:Position2di)
		IrrGUI_ICursorControl_setPositionIntFromPos(handle,pos.handle)
	EndMethod
	
	Method setPositionFloat(x:Float,y:Float)
		IrrGUI_ICursorControl_setPositionFloat(handle,x,y)
	EndMethod
	
	Method setPositionFloatFromPos(pos:Position2df)
		IrrGUI_ICursorControl_setPositionFloatFromPos(handle,pos.handle)
	EndMethod

	Method setReferenceRect(rect:Recti = Null)		
		IrrGUI_ICursorControl_setReferenceRect(handle,_HANDLE(rect))
	EndMethod
	
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrGUI_ICursorControl_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrGUI_ICursorControl_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrGUI_ICursorControl_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

EndType
