' ------------------------------------------------------------------------------------
'  irr::gui::IGUIContextMenu wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------
Type IGUIContextMenu Extends IGUIElement Final

	Function createFromHandle:IGUIContextMenu(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIContextMenu=New IGUIContextMenu
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method addItem:Int(text:String,commandId:Int=-1,bEnabled:Int=True,bHasSubMenu:Int=False,bChecked:Int=False, bAutoChecking:Int = False)
		Return IrrGUI_IGUIContextMenu_addItem(handle,text,commandId,bEnabled,bHasSubMenu,bChecked, bAutoChecking)
	EndMethod

	Method insertItem:Int(idx:Int, text:String, commandId:Int = -1, bEnabled:Int = True, bHasSubMenu:Int = False, bChecked:Int = False, bAutoChecking:Int = False)
		IrrGUI_IGUIContextMenu_insertItem(handle,idx:Int, text, commandId, bEnabled, bHasSubMenu, bChecked, bAutoChecking)
	EndMethod
	
	Method findItemWithCommandId:Int(commandId:Int, idxStartSearch:Int = 0)
		IrrGUI_IGUIContextMenu_findItemWithCommandId(handle, commandId, idxStartSearch)
	EndMethod

	Method addSeparator()
		IrrGUI_IGUIContextMenu_addSeparator(handle)
	EndMethod
	
	Method getItemCommandId:Int(idx:Int)
		Return IrrGUI_IGUIContextMenu_getItemCommandId(handle,idx)
	EndMethod
	
	Method getItemCount:Int()
		IrrGUI_IGUIContextMenu_getItemCount(handle)
	EndMethod
	
	Method getItemText:String(idx:Int)
		Return IrrGUI_IGUIContextMenu_getItemText(handle,idx)
	EndMethod
	
	Method getSelectedItem:Int()
		Return IrrGUI_IGUIContextMenu_getSelectedItem(handle)
	EndMethod
	
	Method getSubMenu:IGUIContextMenu(idx:Int)
		Return IGUIContextMenu.createFromHandle(IrrGUI_IGUIContextMenu_getSubMenu(handle,idx))
	EndMethod
	
	Method isItemEnabled:Int(idx:Int)
		Return IrrGUI_IGUIContextMenu_isItemEnabled(handle,idx)
	EndMethod
	
	Method removeAllItems()
		IrrGUI_IGUIContextMenu_removeAllItems(handle)
	EndMethod
	
	Method removeItem(idx:Int)
		IrrGUI_IGUIContextMenu_removeItem(handle,idx)
	EndMethod
	
	Method setItemCommandId(idx:Int,id:Int)
		IrrGUI_IGUIContextMenu_setItemCommandId(handle,idx,id)
	EndMethod
	
	Method setItemEnabled(idx:Int,bEnabled:Int)
		IrrGUI_IGUIContextMenu_setItemEnabled(handle,idx,bEnabled)
	EndMethod
	
	Method setItemChecked(idx:Int,bEnabled:Int)
		IrrGUI_IGUIContextMenu_setItemChecked(handle,idx,bEnabled)
	EndMethod

	Method isItemChecked:Int(idx:Int)
		Return IrrGUI_IGUIContextMenu_isItemChecked(handle,idx)
	EndMethod
	
	Method setItemText(idx:Int,text:String)
		IrrGUI_IGUIContextMenu_setItemText(handle,idx,text)
	EndMethod

	Method setCloseHandling(ECONTEXT_MENU_CLOSE:Int)
		IrrGUI_IGUIContextMenu_setCloseHandling(handle, ECONTEXT_MENU_CLOSE)
	EndMethod
	
	Method getCloseHandling:Int() ' returns ECONTEXT_MENU_CLOSE
		Return IrrGUI_IGUIContextMenu_getCloseHandling:Int(handle) 
	EndMethod
	
	Method setItemAutoChecking(idx:Int, bAutoChecking:Int)
		IrrGUI_IGUIContextMenu_setItemAutoChecking(handle, idx, bAutoChecking)
	EndMethod
	
	Method getItemAutoChecking:Int(idx:Int)
		Return IrrGUI_IGUIContextMenu_getItemAutoChecking(handle, idx)
	EndMethod
	
	Method setEventParent(parent:IGUIElement)
		IrrGUI_IGUIContextMenu_setEventParent(handle, _HANDLE(parent))
	EndMethod

EndType

