' ------------------------------------------------------------------------------------
'  irr::gui::IGUIEditBox wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------

Public

Type IGUIEditBox Extends IGUIElement Final

	Function createFromHandle:IGUIEditBox(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIEditBox=New IGUIEditBox
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getMax:Int()
		Return IrrGUI_IGUIEditBox_getMax(handle)
	EndMethod
	
	Method setMax(nMax:Int)
		IrrGUI_IGUIEditBox_setMax(handle,nMax)
	EndMethod
	
	Method enableOverrideColor(bEnable:Int)
		IrrGUI_IGUIEditBox_enableOverrideColor(handle,bEnable)
	EndMethod
	
	Method setOverrideColor(color:SColor)
		IrrGUI_IGUIEditBox_setOverrideColor(handle,color.handle)
	EndMethod
	
	Method setOverrideFont(font:IGUIFont=Null)
		If font=Null Then font=New IGUIFont ' default handle to 0
		IrrGUI_IGUIEditBox_setOverrideFont(handle,font.handle)
	EndMethod

	Method setDrawBorder(bBorder:Int)
		IrrGUI_IGUIEditBox_setDrawBorder(handle,bBorder)
	EndMethod
	
	Method setTextAlignment(EGUI_ALIGNMENT_horizontal:Int, EGUI_ALIGNMENT_vertical:Int)
		IrrGUI_IGUIEditBox_setTextAlignment(handle,EGUI_ALIGNMENT_horizontal, EGUI_ALIGNMENT_vertical)
	EndMethod
	
	Method setWordWrap(bEnable:Int)
		IrrGUI_IGUIEditBox_setWordWrap(handle,bEnable)
	EndMethod
	
	Method isWordWrapEnabled:Int()
		Return IrrGUI_IGUIEditBox_isWordWrapEnabled(handle)
	EndMethod
	
	Method setMultiLine(bEnable:Int)
		IrrGUI_IGUIEditBox_setMultiLine(handle,bEnable)
	EndMethod
	
	Method isMultiLineEnabled:Int()
		Return IrrGUI_IGUIEditBox_isMultiLineEnabled(handle)
	EndMethod
	
	Method setAutoScroll(bEnable:Int)
		IrrGUI_IGUIEditBox_setAutoScroll(handle,bEnable)
	EndMethod
	
	Method isAutoScrollEnabled:Int()
		Return IrrGUI_IGUIEditBox_isAutoScrollEnabled(handle)
	EndMethod
	
	Method setPasswordBox(bPasswordBox:Int, passwordChar:String = "*")
		IrrGUI_IGUIEditBox_setPasswordBox(handle, bPasswordBox, StringToWChar(passwordChar))
	EndMethod
	
	Method isPasswordBox:Int()
		Return IrrGUI_IGUIEditBox_isPasswordBox:Int(handle)
	EndMethod
	
	' must delete
	Method getTextDimension:Dimension2di()
		Return Dimension2di.createFromHandle(IrrGUI_IGUIEditBox_getTextDimension(handle), True)
	EndMethod

EndType


