' ------------------------------------------------------------------------------------
'  irr::gui::IGUIElementFactory wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------

Public

Type IGUIElementFactory Extends IReferenceCounted Final

	Function createFromHandle:IGUIElementFactory(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIElementFactory=New IGUIElementFactory
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrGUI_IGUIElementFactory_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrGUI_IGUIElementFactory_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrGUI_IGUIElementFactory_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

	Method addGUIElementByType:IGUIElement(EGUI_ELEMENT_TYPE:Int,parent:IGUIElement=Null)
		If Not parent Or Not parent.IsValid() Then parent=new IGUIElement
		Local element:IGUIElement=IGUIElement.createFromHandle(IrrGUI_IGUIElementFactory_addGUIElementByType(handle,EGUI_ELEMENT_TYPE,parent.handle),True)
		If element Then Return element.cast() Else Return Null
	EndMethod
	
	Method addGUIElementByName:IGUIElement(typeName:String,parent:IGUIElement=Null)
		If Not parent Or Not parent.IsValid() Then parent=new IGUIElement
		Local element:IGUIElement=IGUIElement.createFromHandle(IrrGUI_IGUIElementFactory_addGUIElementByName(handle,typeName,parent.handle),True)
		If element Then Return element.cast() Else Return Null
	EndMethod
	
	Method getCreateableGUIElementTypeCount:Int()
		Return IrrGUI_IGUIElementFactory_getCreatableGUIElementTypeCount(handle) 
	EndMethod
	
	Method getCreateableGUIElementType:Int(idx:Int)
		Return IrrGUI_IGUIElementFactory_getCreateableGUIElementType(handle,idx)
	EndMethod
	
	Method getCreateableGUIElementTypeNameByIdx:String(idx:Int)
		Return IrrGUI_IGUIElementFactory_getCreateableGUIElementTypeNameByIdx(handle,idx)
	EndMethod
	
	Method getCreateableGUIElementTypeNameByType:String(EGUI_ELEMENT_TYPE:Int)
		Return IrrGUI_IGUIElementFactory_getCreateableGUIElementTypeNameByType(handle,EGUI_ELEMENT_TYPE)
	EndMethod

EndType
