Public

' ------------------------------------------------------------------------------------
' IGUITreeViewNode
' ------------------------------------------------------------------------------------

Type IGUITreeViewNode Extends IReferenceCounted Final

	Method getOwner:IGUITreeView()
		Return IGUITreeView.createFromHandle(IrrGUI_IGUITreeViewNode_getOwner(handle), False)
	EndMethod
	
	Method getParent:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_getParent(handle), False)
	EndMethod
	
	Method getText:String()
		Return WCharToString(IrrGUI_IGUITreeViewNode_getText(handle))
	EndMethod
	
	Method setText(text:String)
		IrrGUI_IGUITreeViewNode_setText(handle, StringToWChar(text))
	EndMethod
	
	Method getIcon:String()
		Return WCharToString(IrrGUI_IGUITreeViewNode_getIcon(handle))
	EndMethod
	
	Method setIcon(icon:String)
		IrrGUI_IGUITreeViewNode_setIcon( handle, StringToWChar(icon))
	EndMethod
	
	Method getImageIndex:Int()
		Return IrrGUI_IGUITreeViewNode_getImageIndex(handle)
	EndMethod
	
	Method setImageIndex(imageIndex:Int)
		IrrGUI_IGUITreeViewNode_setImageIndex( handle, imageIndex )
	EndMethod
	
	Method getSelectedImageIndex:Int()
		Return IrrGUI_IGUITreeViewNode_getSelectedImageIndex(handle)
	EndMethod
	
	Method setSelectedImageIndex(imageIndex:Int)
		IrrGUI_IGUITreeViewNode_setSelectedImageIndex(handle, imageIndex)
	EndMethod
	
	Method getData:Byte Ptr()
		Return IrrGUI_IGUITreeViewNode_getData(handle)
	EndMethod
	
	Method setData(data:Byte Ptr)
		IrrGUI_IGUITreeViewNode_setData( handle, data)
	EndMethod
	
	' NOTE: use the types createFromHandle on the return value 
	Method getData2:Int()
		Return IrrGUI_IGUITreeViewNode_getData2(handle)
	EndMethod
	
	Method setData2(data2:IReferenceCounted)
		IrrGUI_IGUITreeViewNode_setData2( handle, _HANDLE(data2))
	EndMethod
	
	Method getChildCount:Int()
		Return IrrGUI_IGUITreeViewNode_getChildCount(handle)
	EndMethod
	
	Method clearChilds()		
		IrrGUI_IGUITreeViewNode_clearChilds(handle)
	EndMethod
	
	Method hasChilds:Int()
		Return IrrGUI_IGUITreeViewNode_hasChilds(handle)
	EndMethod
	
	Method addChildBack:IGUITreeViewNode(text:String, icon:String = Null, imageIndex:Int = -1, selectedImageIndex:Int = -1, data:Byte Ptr = Null, data2:IReferenceCounted = Null)
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_addChildBack(handle, StringToWChar(text), StringToWChar(icon), imageIndex, selectedImageIndex, data, _HANDLE(data2)), False)
	EndMethod
	
	Method addChildFront:IGUITreeViewNode(text:String, icon:String = Null, imageIndex:Int = -1, selectedImageIndex:Int = -1, data:Byte Ptr = Null, data2:IReferenceCounted = Null)
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_addChildFront(handle, StringToWChar(text), StringToWChar(icon), imageIndex, selectedImageIndex, data, _HANDLE(data2)), False)
	EndMethod
	
	Method insertChildAfter:IGUITreeViewNode(other:IGUITreeViewNode, text:String, icon:String = Null, imageIndex:Int = -1, selectedImageIndex:Int = -1, data:Byte Ptr = Null, data2:IReferenceCounted = Null)
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_insertChildAfter(handle, _HANDLE(other), StringToWChar(text), StringToWChar(icon), imageIndex, selectedImageIndex, data, _HANDLE(data2)), False)
	EndMethod
	
	Method insertChildBefore:IGUITreeViewNode(other:IGUITreeViewNode, text:String, icon:String = Null, imageIndex:Int = -1, selectedImageIndex:Int = -1, data:Byte Ptr = Null, data2:IReferenceCounted = Null)
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_insertChildBefore(handle, _HANDLE(other), StringToWChar(text), StringToWChar(icon), imageIndex, selectedImageIndex, data, _HANDLE(data2)), False)
	EndMethod
	
	Method getFirstChild:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_getFirstChild(handle), False)
	EndMethod
	
	Method getLastChild:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_getLastChild(handle), False)
	EndMethod

	Method getPrevSibling:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_getPrevSibling(handle), False)
	EndMethod

	Method getNextSibling:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_getNextSibling(handle), False)
	EndMethod

	Method getNextVisible:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeViewNode_getNextVisible(handle), False)
	EndMethod

	Method deleteChild:Int(child:IGUITreeViewNode)
		Return IrrGUI_IGUITreeViewNode_deleteChild(handle, _HANDLE(child))
	EndMethod
	
	Method moveChildUp:Int(child:IGUITreeViewNode)
		Return IrrGUI_IGUITreeViewNode_moveChildUp(handle, _HANDLE(child))
	EndMethod
	
	Method moveChildDown:Int(child:IGUITreeViewNode)
		Return IrrGUI_IGUITreeViewNode_moveChildDown(handle, _HANDLE(child))
	EndMethod
	
	Method getExpanded:Int()
		Return IrrGUI_IGUITreeViewNode_getExpanded(handle)
	EndMethod
	
	Method setExpanded(bExpanded:Int)
		IrrGUI_IGUITreeViewNode_setExpanded( handle, bExpanded )
	EndMethod
	
	Method getSelected:Int()
		IrrGUI_IGUITreeViewNode_getSelected(handle)
	EndMethod
	
	Method setSelected(bSelected:Int)
		IrrGUI_IGUITreeViewNode_setSelected( handle, bSelected )
	EndMethod
	
	Method isRoot:Int()
		Return IrrGUI_IGUITreeViewNode_isRoot(handle)
	EndMethod
	
	Method getLevel:Int()
		Return IrrGUI_IGUITreeViewNode_getLevel(handle)
	EndMethod
	
	Method isVisible:Int()
		Return IrrGUI_IGUITreeViewNode_isVisible(handle) 
	EndMethod
	
	Function createFromHandle:IGUITreeViewNode(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IGUITreeViewNode=New IGUITreeViewNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

 	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrGUI_IGUITreeViewNode_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrGUI_IGUITreeViewNode_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrGUI_IGUITreeViewNode_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
EndType


' ------------------------------------------------------------------------------------
' IGUITreeView
' ------------------------------------------------------------------------------------

Type IGUITreeView Extends IGUIElement Final

	Method getRoot:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeView_getRoot(handle), False)
	EndMethod
	
	Method getSelected:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeView_getSelected(handle), False)
	EndMethod
	
	Method getLinesVisible:Int()
		Return IrrGUI_IGUITreeView_getLinesVisible(handle)
	EndMethod
	
	Method setLinesVisible(bVisible:Int)
		IrrGUI_IGUITreeView_setLinesVisible( handle, bVisible)
	EndMethod
	
	Method setIconFont(font:IGUIFont)
		IrrGUI_IGUITreeView_setIconFont( handle, _HANDLE(font))
	EndMethod
	
	Method setImageList(imageList:IGUIImageList)
		IrrGUI_IGUITreeView_setImageList( handle, _HANDLE(imageList))
	EndMethod
	
	Method getImageList:IGUIImageList()
		Return IGUIImageList.createFromHandle(IrrGUI_IGUITreeView_getImageList(handle), False)
	EndMethod
	
	Method setImageLeftOfIcon(bLeftOf:Int)
		IrrGUI_IGUITreeView_setImageLeftOfIcon( handle, bLeftOf )
	EndMethod
	
	Method getImageLeftOfOcon:Int()
		Return IrrGUI_IGUITreeView_getImageLeftOfIcon(handle)
	EndMethod
	
	Method getLastEventNode:IGUITreeViewNode()
		Return IGUITreeViewNode.createFromHandle(IrrGUI_IGUITreeView_getLastEventNode(handle), False)
	EndMethod

	Function createFromHandle:IGUITreeView(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUITreeView=New IGUITreeView
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
		
EndType

