// Copyright (C) 2002-2006 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_UNKNOWN_DELETE_CALLBACK_H_INCLUDED__
#define __I_UNKNOWN_DELETE_CALLBACK_H_INCLUDED__

#include "IUnknown.h"

namespace irr
{
	class IUnknownDeleteCallback : public irr::IUnknown
	{
	public:

		//! destructor
		virtual ~IUnknownDeleteCallback() {}

		/// <summary>
		/// Called right before an IUnknown is deleted
		/// </summary>
		/// \param node: IUnknown being deleted
		virtual void onDelete(IUnknown* unk) = 0;
	};
} // end namespace 

#endif

