Public

' enum EFileSystemType
Const FILESYSTEM_NATIVE:Int = 0
Const FILESYSTEM_VIRTUAL:Int = 1

' enum E_FILE_ARCHIVE_TYPE
Global EFAT_ZIP:Int    = Irr_MAKE_IRR_ID("Z".ToCString()[0],"I".ToCString()[0],"P".ToCString()[0], "".ToCString()[0])
Global EFAT_GZIP:Int    = Irr_MAKE_IRR_ID("g".ToCString()[0],"z".ToCString()[0],"i".ToCString()[0], "p".ToCString()[0])
Global EFAT_FOLDER:Int  = Irr_MAKE_IRR_ID("f".ToCString()[0],"l".ToCString()[0],"d".ToCString()[0], "r".ToCString()[0])
Global EFAT_PAK:Int     = Irr_MAKE_IRR_ID("P".ToCString()[0],"A".ToCString()[0],"K".ToCString()[0], "".ToCString()[0])
Global EFAT_NPK:Int     = Irr_MAKE_IRR_ID("N".ToCString()[0],"P".ToCString()[0],"K".ToCString()[0], "".ToCString()[0])
Global EFAT_TAR:Int     = Irr_MAKE_IRR_ID("T".ToCString()[0],"A".ToCString()[0],"R".ToCString()[0], "".ToCString()[0])
Global EFAT_UNKNOWN:Int = Irr_MAKE_IRR_ID("u".ToCString()[0],"n".ToCString()[0],"k".ToCString()[0], "n".ToCString()[0])

Extern 

	' ----------------------------------------------------------------
	' IFileArchive
	' ----------------------------------------------------------------
	
	Function IrrIO_IFileArchive_createAndOpenFile:Int(pIFileArchive:Int, filename$z) ' returns IReadFile*
	Function IrrIO_IFileArchive_createAndOpenFileByIndex:Int(pIFileArchive:Int, index:Int) ' returns IReadFile*
	' do not delete
	Function IrrIO_IFileArchive_getFileList(pIFileArchive:Int) ' returns IFileList*	
	Function IrrIO_IFileArchive_getType:Int(pIFileArchive:Int) ' returns E_FILE_ARCHIVE_TYPE
	Function IrrIO_IFileArchive_setPassword(pIFileArchive:Int, password$z) 
	Function IrrIO_IFileArchive_getPassword$z(pIFileArchive:Int) 

	Function IrrIO_IFileArchive_drop:Int(pIFileArchive:Int)	
	Function IrrIO_IFileArchive_getDebugName$z(pIFileArchive:Int)
	Function IrrIO_IFileArchive_grab(pIFileArchive:Int)

	' ----------------------------------------------------------------
	' IArchiveLoader
	' ----------------------------------------------------------------
	Function IrrIO_IArchiveLoader_isALoadableFileFormat:Int(pIArchiveLoader:Int, filename$z)
	Function IrrIO_IArchiveLoader_isALoadableFileFormatFromIO:Int(pIArchiveLoader:Int, pIReadFile:Int)
	Function IrrIO_IArchiveLoader_isALoadableFileFormatFromType:Int(pIArchiveLoader:Int, E_FILE_ARCHIVE_TYPE:Int) 
	Function IrrIO_IArchiveLoader_createArchive:Int(pIArchiveLoader:Int, filename$z, bIgnoreCase:Int, bIgnorePaths:Int)  ' returns IFileArchive*
	Function IrrIO_IArchiveLoader_createArchiveFromIO:Int(pIArchiveLoader:Int, pIReadFile:Int, bIgnoreCase:Int, bIgnorePaths:Int) ' returns IFileArchive*


	Function IrrIO_IArchiveLoader_drop:Int(pIArchiveLoader:Int)
	Function IrrIO_IArchiveLoader_getDebugName$z(pIArchiveLoader:Int)
	Function IrrIO_IArchiveLoader_grab(pIArchiveLoader:Int)

EndExtern