' ------------------------------------------------------------------------------------
' irr::SIrrlichtCreationParameters wrapper
' ------------------------------------------------------------------------------------
Public

Type SIrrlichtCreationParameters Extends IrrBase Final
	
	Function createFromHandle:SIrrlichtCreationParameters(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SIrrlichtCreationParameters=New SIrrlichtCreationParameters
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then Irr_SIrrlichtCreationParameters_del(handle)
	EndMethod	

	Function create:SIrrlichtCreationParameters()
		Return SIrrlichtCreationParameters.createFromHandle(Irr_SIrrlichtCreationParameters_new())
	EndFunction

	Method createFromOther:SIrrlichtCreationParameters(other:SIrrlichtCreationParameters)
		Return SIrrlichtCreationParameters.createFromHandle(Irr_SIrrlichtCreationParameters_newFromOther(other.handle), True)
	EndMethod

	Method setEq:SIrrlichtCreationParameters(other:SIrrlichtCreationParameters)
		Irr_SIrrlichtCreationParameters_setEq(handle, other.handle)
		Return Self
	EndMethod

	Method getAntiAlias:Byte()
		Return Irr_SIrrlichtCreationParameters_getAntiAlias(handle)
	EndMethod
	
	Method setAntiAlias(bAntiAlias:Byte)
		Irr_SIrrlichtCreationParameters_setAntiAlias(handle,bAntiAlias)
	EndMethod

	Method getBits:Byte()
		Return Irr_SIrrlichtCreationParameters_getBits(handle)
	EndMethod

	Method setBits(bits:Byte)
		Irr_SIrrlichtCreationParameters_setBits(handle,bits)
	EndMethod

	Method getDriverType:Int()
		Return Irr_SIrrlichtCreationParameters_getDriverType(handle)
	EndMethod

	Method setDriverType(E_DRIVER_TYPE_type:Int)
		Irr_SIrrlichtCreationParameters_setDriverType(handle,E_DRIVER_TYPE_type)
	EndMethod

	Method getEventReceiver:IEventReceiver(EventReceiverGenerateFunction:Byte Ptr)
		Return IEventReceiver.createFromHandle(EventReceiverGenerateFunction,Irr_SIrrlichtCreationParameters_getEventReceiver(handle),False)
	EndMethod

	Method setEventReceiver(recv:IEventReceiver)
		Irr_SIrrlichtCreationParameters_setEventReceiver(handle,recv.handle)
	EndMethod

	Method getFullscreen:Int()
		Return Irr_SIrrlichtCreationParameters_getFullscreen(handle)
	EndMethod

	Method setFullscreen(bFullscreen:Int)
		Irr_SIrrlichtCreationParameters_setFullscreen(handle,bFullscreen)
	EndMethod

	Method getStencilbuffer:Int()
		Return Irr_SIrrlichtCreationParameters_getStencilbuffer(handle)
	EndMethod

	Method setStencilbuffer(bSbuffer:Int)
		Irr_SIrrlichtCreationParameters_setStencilbuffer(handle,bSbuffer)
	EndMethod

	Method getVsync:Int()
		Return Irr_SIrrlichtCreationParameters_getVsync(handle)
	EndMethod

	Method setVsync(bVS:Int)
		Irr_SIrrlichtCreationParameters_setVsync(handle,bVS)
	EndMethod

	Method getWindowId:Int()
		Return Irr_SIrrlichtCreationParameters_getWindowId(handle)
	EndMethod

	Method setWindowId(hwnd:Int)
		Irr_SIrrlichtCreationParameters_setWindowId(handle,hwnd)
	EndMethod

	Method getWindowSize:Dimension2di()
		Return Dimension2di.createFromHandle(Irr_SIrrlichtCreationParameters_getWindowSize(handle), True)
	EndMethod

	Method setWindowSize(size:Dimension2di)
		Irr_SIrrlichtCreationParameters_setWindowSize(handle,size.handle)
	EndMethod

	Method getHighPrecisionFPU:Int()
		Return Irr_SIrrlichtCreationParameters_getHighPrecisionFPU(handle)
	EndMethod
	
	Method setHighPrecisionFPU(bHighPrecision:Int=False)
		Irr_SIrrlichtCreationParameters_setHighPrecisionFPU(handle,bHighPrecision)
	EndMethod

	Method getZBufferBits:Byte()
		Return Irr_SIrrlichtCreationParameters_getZBufferBits(handle)
	EndMethod

	Method setZBufferBits(bits:Byte)
		Irr_SIrrlichtCreationParameters_setZBufferBits(handle,bits)
	EndMethod

	Method getWithAlphaChannel:Int()
		Return Irr_SIrrlichtCreationParameters_getWithAlphaChannel(handle)
	EndMethod

	Method setWithAlphaChannel(bWithAlphaChannel:Int)
		Irr_SIrrlichtCreationParameters_setWithAlphaChannel(handle,bWithAlphaChannel)
	EndMethod

	Method getIgnoreInput:Int()
		Return Irr_SIrrlichtCreationParameters_getIgnoreInput(handle)
	EndMethod

	Method setIgnoreInput(bIgnoreInput:Int)
		Irr_SIrrlichtCreationParameters_setIgnoreInput(handle,bIgnoreInput)
	EndMethod
	
	Method getDeviceType:Int()
		Return Irr_SIrrlichtCreationParameters_getDeviceType(handle)
	EndMethod
	
	Method setDeviceType(E_DEVICE_TYPE:Int)
		Irr_SIrrlichtCreationParameters_setDeviceType(handle, E_DEVICE_TYPE)
	EndMethod
	
	Method getDoublebuffer:Int()
		Return Irr_SIrrlichtCreationParameters_getDoublebuffer(handle)
	EndMethod
	
	Method setDoublebuffer(bDoubleBuffer:Int)
		Irr_SIrrlichtCreationParameters_setDoublebuffer(handle, bDoubleBuffer)
	EndMethod
	
	Method getStereobuffer:Int()
		Return Irr_SIrrlichtCreationParameters_getStereobuffer(handle)
	EndMethod
	
	Method setStereobuffer(bStereoBuffer:Int)
		Irr_SIrrlichtCreationParameters_setStereobuffer(handle, bStereoBuffer)
	EndMethod

	Method getLoggingLevel:Int() ' returns ELOG_LEVEL 
		Return Irr_SIrrlichtCreationParameters_getLoggingLevel(handle)
	EndMethod
	
	Method setLoggingLevel(ELOG_LEVEL:Int)
		Irr_SIrrlichtCreationParameters_setLoggingLevel(handle, ELOG_LEVEL)
	EndMethod

EndType


