' ------------------------------------------------------------------------------------
' irr::scene::IQ3LevelMesh wrappers (parent is IAnimatedMesh)
' ------------------------------------------------------------------------------------
Public

Type IQ3LevelMesh Extends IAnimatedMesh Final

	Function createFromHandle:IQ3LevelMesh(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IQ3LevelMesh=New IQ3LevelMesh
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getShader:IShader(filename:String,fileNameIsValid:Int = True)
		Return IShader.createFromHandle(IrrScene_IQ3LevelMesh_getShader(handle,filename,fileNameIsValid),False)
	EndMethod
	
	Method getShaderByIdx:IShader(index:Int)
		Return IShader.createFromHandle(IrrScene_IQ3LevelMesh_getShaderByIdx(handle,index),False)
	EndMethod
	
	Method getEntityList:IShader[]()
		Local ptrs:Int Ptr	
		Local objs:IShader[]=Null				

		Local size:Int=IrrScene_IQ3LevelMesh_getEntityList(handle,Varptr(ptrs))
		If size>0 Then		
			objs=New IShader[size]

			For Local i:Int=0 Until size
				objs[i]=IShader.createFromHandle(ptrs[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		
		Return objs				
	EndMethod

EndType		
