' ------------------------------------------------------------------------------------
'  irr::scene::ISceneNodeAnimatorCollisionResponse wrappers (based on ISceneNodeAnimator)
' ------------------------------------------------------------------------------------
Public

' ------------------------------------------------------------------------------------
' IVertexManipulator
' ------------------------------------------------------------------------------------

Type IVertexManipulator Extends IrrBase
	
	' --------------------------------------------------------------------------------
	' override these in extended type to implement new functionality
	' --------------------------------------------------------------------------------
	
	Method onManipulate(vertex:S3DVertex) Abstract
	
	' --------------------------------------------------------------------------------
	' base routines
	' --------------------------------------------------------------------------------

	Method Delete()
		If (mustdelete) Then IrrScene_BMXIVertexManipulator_del(handle)
	EndMethod	

	' --------------------------------------------------------------------------------
	' creation routines
	' --------------------------------------------------------------------------------

	' this should only be called on an extended type
	Function create:IVertexManipulator(pGenFunc:Byte Ptr) Final
		Return createFromHandle(IrrScene_BMXIVertexManipulator_new(),True,pGenFunc)
	EndFunction

	Function createFromHandle:IVertexManipulator(pHandle:Int,bMustDel:Int,pGenFunc:Byte Ptr) Final
		If Not pHandle Then Return Null
		Local oRetVal:IVertexManipulator = Null
		
		If pGenFunc
			' use the funtion pointer to generate
			Local generate:IVertexManipulator() = pGenFunc
		
			oRetVal=generate()
		EndIf

		' turn binding on if this is the first and there was a gen func passed in
		oRetVal.bIsBound=bMustDel And pGenFunc
		
		oRetVal.attach(pHandle,bMustDel)
		
		Return oRetVal
	EndFunction

	' --------------------------------------------------------------------------------
	' bindings
	' --------------------------------------------------------------------------------

	Method bind(rec:Int) Final
		Super.bind(rec)
	EndMethod

	Method getBinderHandle:Int()
		Return IrrScene_BMXIVertexManipulator_getBinder(handle)
	EndMethod

	Function BoundOnManipulate(binding:Int, s3d_vertex:Int)
		' get the object whose node is firing
		Local tempobj:IVertexManipulator = IVertexManipulator(translate(binding))
		
		If tempobj<>Null
			Local obj:S3DVertex = S3DVertex.createFromHandle(s3d_vertex, False)
							
  			' fire the event
	  		tempobj.onManipulate(obj)
		Else
			Throw "Unable to find bound object"
		EndIf	
	EndFunction

EndType
