Public

' ------------------------------------------------------------------------------------
' irr::video::SColor Function wrappers
' ------------------------------------------------------------------------------------

Function irr_RGB16:Short(r:Int,g:Int,b:Int)
	Return IrrVideo_Func_RGB16(r,g,b)
EndFunction

Function irr_RGBA16:Short(r:Int,g:Int,b:Int,a:Int)
	Return IrrVideo_Func_RGBA16(r,g,b,a)
EndFunction

Function irr_X8R8G8B8toA1R5G5B5:Short(color:Int)
	Return IrrVideo_Func_X8R8G8B8toA1R5G5B5(color)
EndFunction

Function irr_A8R8G8B8toR5G6B5:Short(color:Int)
	Return IrrVideo_Func_A8R8G8B8toR5G6B5(color) 
EndFunction

Function irr_getAlpha:Int(color:Short)
	Return IrrVideo_Func_getAlpha(color)
EndFunction

Function irr_getRed:Int(color:Short)
	Return IrrVideo_Func_getRed(color)
EndFunction

Function irr_getGreen:Int(color:Short)
	Return IrrVideo_Func_getGreen(color)
EndFunction

Function irr_getBlue:Int(color:Short)
	Return IrrVideo_Func_getBlue(color)
EndFunction

Function irr_A1R5G5B5toA8R8G8B8:Int(color:Short)
	Return IrrVideo_Func_A1R5G5B5toA8R8G8B8(color)
EndFunction

Function irr_R5G6B5toA8R8G8B8:Int(color:Short)
	Return IrrVideo_Func_R5G6B5toA8R8G8B8(color)
EndFunction

Function irr_R5G6B5toA1R5G5B5:Short(color:Short)
	Return IrrVideo_Func_R5G6B5toA1R5G5B5(color)
EndFunction

Function irr_A1R5G5B5toR5G6B5:Short(color:Short)
	Return IrrVideo_Func_A1R5G5B5toR5G6B5(color)
EndFunction

Function irr_A8R8G8B8toA1R5G5B5:Short(color:Int)
	Return IrrVideo_Func_A8R8G8B8toA1R5G5B5(color)
EndFunction

Function RGB16from16:Short(r:Short,g:Short,b:Short)
	Return IrrVideo_Func_RGB16from16(r,g,b)
EndFunction

Function getAverage:Int(color:Short)
	Return IrrVideo_Func_getAverage(color)
EndFunction

Type SColor Extends IrrBase Final
	
	' ------------------------------------------------------------------------------------
	' irr::video::SColor wrappers
	' ------------------------------------------------------------------------------------

	Function createFromHandle:SColor(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SColor=New SColor
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrVideo_SColor_del(handle)
	EndMethod	
		
	Function create:SColor()
		Return createFromHandle(IrrVideo_SColor_new())
	EndFunction
	
	Function createFromVals:SColor(a:Int,r:Int,g:Int,b:Int)
		Return createFromHandle(IrrVideo_SColor_newFromVals(a,r,g,b))
	EndFunction
	
	Function createFromColorVal:SColor(color:Int)
		Return createFromHandle(IrrVideo_SColor_newFromColorVal(color))
	EndFunction
	
	Method GetAlpha:Int()
		Return IrrVideo_SColor_getAlpha(handle)
	EndMethod

	Method getRed:Int()
		Return IrrVideo_SColor_getRed(handle)
	EndMethod

	Method getGreen:Int()
		Return IrrVideo_SColor_getGreen(handle)
	EndMethod

	Method getBlue:Int()
		Return IrrVideo_SColor_getBlue(handle)
	EndMethod
	
	Method SetAlpha(val:Int)
		IrrVideo_SColor_setAlpha(handle,val)
	EndMethod

	Method setRed(val:Int)
		IrrVideo_SColor_setRed(handle,val)
	EndMethod

	Method setGreen(val:Int)
		IrrVideo_SColor_setGreen(handle,val)
	EndMethod

	Method setBlue(val:Int)
		IrrVideo_SColor_setBlue(handle,val)
	EndMethod

	Method toA1R5G5B5:Short()
		Return IrrVideo_SColor_toA1R5G5B5(handle)
	EndMethod

	Method toOpenGLColor:Byte[]()
		Local oglColor:Byte[]=new Byte[4]
		IrrVideo_SColor_toOpenGLColor(handle,oglColor)
		Return oglColor
	EndMethod
	
	Method set(a:Int,r:Int,g:Int,b:Int)
		IrrVideo_SColor_set(handle,a,r,g,b)
	EndMethod
	
	Method EqEq:Int(other:SColor)
		Return IrrVideo_SColor_EqEq(handle,other.handle)
	EndMethod

	Method NotEq:Int(other:SColor)
		Return IrrVideo_SColor_NotEq(handle,other.handle)
	EndMethod

	Method Plus:SColor(other:SColor)
		Return SColor.createFromHandle(IrrVideo_SColor_plus(handle,other.handle),True)
	EndMethod

	Method getInterpolated:SColor(other:SColor,d:Float)
		Return createFromHandle(IrrVideo_SColor_getInterpolated(handle,other.handle,d))
	EndMethod
	
	Method GetColor:Int()
		Return IrrVideo_SColor_getColor(handle)
	EndMethod

	Method getLuminance:Float()
		Return IrrVideo_SColor_getLuminance(handle)
	EndMethod
	
	Method getAverage:Int()
		Return IrrVideo_SColor_getAverage(handle)
	EndMethod
	
	Method getInterpolated_quadratic:SColor(c1:SColor,c2:SColor,d:Float)
		Return SColor.createFromHandle(IrrVideo_SColor_getInterpolated_quadratic(handle,c1.handle,c2.handle,d),True)
	EndMethod
	
	Method getLightness:Float()
		Return IrrVideo_SColor_getLightness(handle)
	EndMethod
EndType
	
Type SColorf Extends IrrBase Final

	' ------------------------------------------------------------------------------------
	' irr::video::SColorf wrappers
	' ------------------------------------------------------------------------------------
	
	Function createFromHandle:SColorf(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SColorf=New SColorf
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrVideo_SColorf_del(handle)
	EndMethod	

	Function create:SColorf()
		Return createFromHandle(IrrVideo_SColorf_new:Int())
	EndFunction
	
	Function createFromRGB:SColorf(r:Float,g:Float,b:Float)
		Return createFromHandle(IrrVideo_SColorf_newFromRGB(r,g,b))
	EndFunction
	
	Function createFromRGBA:SColorf(r:Float,g:Float,b:Float,a:Float=1.0)
		Return createFromHandle(IrrVideo_SColorf_newFromRGBA:Int(r,g,b,a))
	EndFunction
	
	Function createFromSColor:SColorf(color:SColor)
		Return createFromHandle(IrrVideo_SColorf_newFromSColor(color.handle))
	EndFunction
		
	Method toSColor:SColor()
		Return SColor.createFromHandle(IrrVideo_SColorf_toSColor(handle))
	EndMethod
	
	Method set(rr:Float,gg:Float,bb:Float)
		IrrVideo_SColorf_set(handle,rr,gg,bb)
	EndMethod
	
	Method setWithAlpha(aa:Float,rr:Float,gg:Float,bb:Float)
		IrrVideo_SColorf_setWithAlpha(handle,aa,rr,gg,bb)
	EndMethod

	Method GetAlpha:Float()
		Return IrrVideo_SColorf_getAlpha(handle)
	EndMethod
	
	Method getRed:Float()
		Return IrrVideo_SColorf_getRed(handle)
	EndMethod

	Method getGreen:Float()
		Return IrrVideo_SColorf_getGreen(handle)
	EndMethod

	Method getBlue:Float()
		Return IrrVideo_SColorf_getBlue(handle)
	EndMethod

	Method getArray:Float Ptr()
		Return IrrVideo_SColorf_getArray(handle)
	EndMethod

	Method getInterpolated:SColorf(other:SColorf,d:Float)
		Return createFromHandle(IrrVideo_SColorf_getInterpolated(handle,other.handle,d))
	EndMethod

	Method setColorComponentValue(index:Int,value:Float)
		IrrVideo_SColorf_setColorComponentValue(handle,index,value)
	EndMethod

	Method getInterpolated_quadratic:SColorf(c1:SColorf,c2:SColorf,d:Float)
		Return SColorf.createFromHandle(IrrVideo_SColorf_getInterpolated_quadratic(handle,c1.handle,c2.handle,d),True)
	EndMethod

EndType

Type SColorHSL Extends IrrBase Final

	' ------------------------------------------------------------------------------------
	' irr::video::SColorHSL wrappers
	' ------------------------------------------------------------------------------------
	
	Function createFromHandle:SColorHSL(pHandle:Int,bMustDel:Int=True)
		If pHandle=0 Then Return Null ' return null if an invalid handle was passed in
		Local oRetVal:SColorHSL=New SColorHSL
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method create:SColorHSL()
		Return createFromHSL()
	EndMethod

	Method createFromHSL:SColorHSL(h:Float=0,s:Float=0,l:Float=0)
		Return createFromHandle(IrrVideo_SColorHSL_new(h,s,l),True)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then IrrVideo_SColorHSL_del(handle)
	EndMethod	

	Method toRGB(color:SColor)
		IrrVideo_SColorHSL_toRGB(handle,color.handle)
	EndMethod
	
EndType